Criar uma monitorização Monitoring
POST/v1/watches
Contrato v1 / 1.0.0 62 / 2026-10-10
Nesta página
Associe um endereço a um projeto Monitoring existente com regras independentes. Os projetos são criados no Account. Um endereço pode ser usado em diferentes projetos. Repetir uma associação exata não é uma API geral de atualização de regras; altere as regras no Account.
Permissões da chave: watches / write / monitoring.
Corpo do pedido
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
project | string | Não | ID do projeto. Obrigatório ao listar ou criar monitorizações salvo chave limitada a projeto. Noutras operações, omitir usa o contexto de conta/projeto da operação; defina explicitamente. |
chain | string | Sim | Código da rede de GET /v1/chains. minLength: 1 |
address | string | Sim | Endereço na rede selecionada; validado e normalizado. minLength: 1 |
asset | string | Não | Ativo predefinido para exact: native, símbolo suportado ou identificador do token. Predefinição: native |
label | string | Não | Etiqueta do livro de endereços. maxLength: 60 |
note | string | Não | Nota facultativa do livro de endereços. maxLength: 280 |
watch_outgoing | boolean | Não | Receber também operações de saída; a rede tem de as suportar. Predefinição: false |
asset_policy | string | Não | exact seleciona um ativo; allow usa asset_ids; all seleciona todos os ativos da rede. Redes sem tokens só suportam native/exact.exact, allow, all; Predefinição: exact |
asset_ids | string[] | Não | Exatamente um para exact, pelo menos um para allow, vazio para all. Com exact e lista vazia, é usado asset. maxItems: 100 |
excluded_asset_ids | string[] | Não | Ativos a excluir. maxItems: 100 |
min_confirmations | integer | Não | Confirmações mínimas. Predefinição: 0; minimum: 0 |
min_amount | string | Não | Limiar não negativo em unidades mínimas, não montante decimal. pattern: ^[0-9]+$ |
watch_contracts | boolean | Não | Receba eventos de contrato suportados. Predefinição: false |
watch_unexpected_assets | boolean | Não | Receba eventos de ativos inesperados. Predefinição: false |
application/json
{
"project": "1002",
"chain": "ethereum",
"address": "0x52908400098527886E0F7030069857D2E4169EE7",
"asset": "native",
"label": "Treasury"
}Exemplos de pedidos
Os exemplos executam uma operação real na conta. Defina as variáveis de ambiente indicadas no código. Mantenha a chave privada; pedidos de escrita não são repetidos automaticamente.
Shell / cURL
#!/usr/bin/env bash
set -euo pipefail
: "${CRYPTANIO_API_KEY:?Set CRYPTANIO_API_KEY}"
: "${CRYPTANIO_PROJECT_ID:?Set CRYPTANIO_PROJECT_ID}"
json_string() {
local text="$1" char code index output='"'
for ((index=0; index<${#text}; index++)); do
char="${text:index:1}"
case "$char" in
'"'|'\') output+="\\$char" ;;
*) printf -v code '%d' "'$char"
if ((code < 32)); then printf -v char '\\u%04x' "$code"; fi
output+="$char" ;;
esac
done
printf '%s"' "$output"
}
response_file="$(mktemp)"
trap 'rm -f "$response_file"' EXIT
transfer_status=0
http_status="$(curl \
--silent --show-error --max-time 30 --request POST \
--header "Authorization: Bearer $CRYPTANIO_API_KEY" \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--data-binary '{"project":'"$(json_string "$CRYPTANIO_PROJECT_ID")"',"chain":"ethereum","address":"0x52908400098527886E0F7030069857D2E4169EE7","asset":"native","label":"Treasury"}' \
"https://api.cryptanio.com/v1/watches" \
--output "$response_file" --write-out '%{http_code}')" || transfer_status=$?
if [[ "$http_status" == 2?? ]]; then
cat "$response_file"
exit "$transfer_status"
fi
printf 'HTTP %s\n' "$http_status" >&2
cat "$response_file" >&2
exit 1
Go
// Go; standard library only. Run: go run request.go
package main
import (
"bytes"
"encoding/json"
"fmt"
"io"
"net/http"
"net/url"
"os"
"time"
)
func env(name string) string {
value := os.Getenv(name)
if value == "" { fmt.Fprintln(os.Stderr, "Set", name); os.Exit(1) }
return value
}
func run() error {
path := "/v1/watches"
endpoint, err := url.Parse("https://api.cryptanio.com" + path)
if err != nil { return err }
query := endpoint.Query()
endpoint.RawQuery = query.Encode()
var payload map[string]any
if err := json.Unmarshal([]byte("{\"project\":\"1002\",\"chain\":\"ethereum\",\"address\":\"0x52908400098527886E0F7030069857D2E4169EE7\",\"asset\":\"native\",\"label\":\"Treasury\"}"), &payload); err != nil { return err }
payload["project"] = env("CRYPTANIO_PROJECT_ID")
body, err := json.Marshal(payload)
if err != nil { return err }
request, err := http.NewRequest("POST", endpoint.String(), bytes.NewReader(body))
if err != nil { return err }
request.Header.Set("Authorization", "Bearer " + env("CRYPTANIO_API_KEY"))
request.Header.Set("Accept", "application/json")
request.Header.Set("Content-Type", "application/json")
client := &http.Client{Timeout: 30 * time.Second, CheckRedirect: func(*http.Request, []*http.Request) error { return http.ErrUseLastResponse }}
response, err := client.Do(request)
if err != nil { return err }
defer response.Body.Close()
if response.StatusCode < 200 || response.StatusCode >= 300 {
body, err := io.ReadAll(response.Body)
if err != nil { return err }
return fmt.Errorf("HTTP %d: %s", response.StatusCode, body)
}
_, err = io.Copy(os.Stdout, response.Body)
return err
}
func main() {
if err := run(); err != nil { fmt.Fprintln(os.Stderr, err); os.Exit(1) }
}
Rust
// Cargo.toml dependencies:
// reqwest = { version = "=0.12.24", features = ["blocking", "json"] }
// serde_json = "=1.0.145"
use std::{error::Error, io, time::Duration};
use reqwest::{blocking::Client, redirect::Policy, Method, Url};
fn env(name: &str) -> Result<String, Box<dyn Error>> {
let value = std::env::var(name)?;
if value.is_empty() { return Err(format!("Set {name}").into()); }
Ok(value)
}
fn run() -> Result<(), Box<dyn Error>> {
let mut url = Url::parse("https://api.cryptanio.com")?;
{
let mut segments = url.path_segments_mut().map_err(|_| "Invalid base URL")?;
segments.clear();
segments.push("v1");
segments.push("watches");
}
let client = Client::builder().timeout(Duration::from_secs(30)).redirect(Policy::none()).build()?;
let request = client.request(Method::POST, url)
.header("Authorization", format!("Bearer {}", env("CRYPTANIO_API_KEY")?))
.header("Accept", "application/json".to_owned())
.header("Content-Type", "application/json".to_owned());
let mut body: serde_json::Value = serde_json::from_str("{\"project\":\"1002\",\"chain\":\"ethereum\",\"address\":\"0x52908400098527886E0F7030069857D2E4169EE7\",\"asset\":\"native\",\"label\":\"Treasury\"}")?;
body["project"] = serde_json::Value::String(env("CRYPTANIO_PROJECT_ID")?);
let request = request.json(&body);
let mut response = request.send()?;
let status = response.status();
if !status.is_success() { return Err(format!("HTTP {}: {}", status.as_u16(), response.text()?).into()); }
io::copy(&mut response, &mut io::stdout())?;
Ok(())
}
fn main() {
if let Err(error) = run() { eprintln!("{error}"); std::process::exit(1); }
}
PHP
<?php
// PHP 8 with the cURL extension. Run this on your server.
function env(string $name): string {
$value = getenv($name);
if ($value === false || $value === '') throw new RuntimeException('Set ' . $name);
return $value;
}
try {
$path = '/v1/watches';
$query = [
];
$url = 'https://api.cryptanio.com' . $path . ($query ? '?' . http_build_query($query, '', '&', PHP_QUERY_RFC3986) : '');
$headers = [
'Authorization: ' . 'Bearer ' . env('CRYPTANIO_API_KEY'),
'Accept: ' . 'application/json',
'Content-Type: ' . 'application/json',
];
$body = json_decode('{"project":"1002","chain":"ethereum","address":"0x52908400098527886E0F7030069857D2E4169EE7","asset":"native","label":"Treasury"}', true, 512, JSON_THROW_ON_ERROR);
$body['project'] = env('CRYPTANIO_PROJECT_ID');
$curl = curl_init($url);
curl_setopt_array($curl, [
CURLOPT_CUSTOMREQUEST => 'POST',
CURLOPT_HTTPHEADER => $headers,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_FOLLOWLOCATION => false,
CURLOPT_CONNECTTIMEOUT => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_POSTFIELDS => json_encode($body, JSON_THROW_ON_ERROR),
]);
$response = curl_exec($curl);
if ($response === false) throw new RuntimeException(curl_error($curl));
$status = curl_getinfo($curl, CURLINFO_HTTP_CODE);
if ($status < 200 || $status >= 300) throw new RuntimeException('HTTP ' . $status . ': ' . $response);
echo $response;
} catch (Throwable $error) {
fwrite(STDERR, $error->getMessage() . PHP_EOL);
exit(1);
}
Python
# Python 3; standard library only.
import json
import os
import sys
from urllib.error import HTTPError, URLError
from urllib.parse import quote, urlencode
from urllib.request import HTTPRedirectHandler, Request, build_opener
def env(name):
result = os.environ.get(name)
if not result:
raise ValueError("Set " + name)
return result
class NoRedirect(HTTPRedirectHandler):
def redirect_request(self, req, fp, code, msg, headers, newurl):
return None
try:
path = "/v1/watches"
query = {
}
url = "https://api.cryptanio.com" + path + ("?" + urlencode(query) if query else "")
headers = {
"Authorization": "Bearer " + env("CRYPTANIO_API_KEY"),
"Accept": "application/json",
"Content-Type": "application/json",
}
body = json.loads("{\"project\":\"1002\",\"chain\":\"ethereum\",\"address\":\"0x52908400098527886E0F7030069857D2E4169EE7\",\"asset\":\"native\",\"label\":\"Treasury\"}")
body["project"] = env("CRYPTANIO_PROJECT_ID")
data = json.dumps(body).encode("utf-8")
request = Request(url, data=data, headers=headers, method="POST")
with build_opener(NoRedirect()).open(request, timeout=30) as response:
if not 200 <= response.status < 300:
raise ValueError("HTTP " + str(response.status))
sys.stdout.buffer.write(response.read())
except HTTPError as error:
print("HTTP " + str(error.code) + ": " + error.read().decode("utf-8", errors="replace"), file=sys.stderr)
sys.exit(1)
except (ValueError, URLError, OSError) as error:
print(str(error), file=sys.stderr)
sys.exit(1)
Node.js
// Node.js 18+. Run on your server, never in a browser.
const env = name => {
const result = process.env[name];
if (!result) throw new Error(`Set ${name}`);
return result;
};
try {
let path = "/v1/watches";
const url = new URL(path, "https://api.cryptanio.com");
const headers = {
"Authorization": "Bearer " + env("CRYPTANIO_API_KEY"),
"Accept": "application/json",
"Content-Type": "application/json",
};
const body = {
"project": "1002",
"chain": "ethereum",
"address": "0x52908400098527886E0F7030069857D2E4169EE7",
"asset": "native",
"label": "Treasury"
};
body["project"] = env("CRYPTANIO_PROJECT_ID");
const response = await fetch(url, {
method: "POST", headers, redirect: "manual",
signal: AbortSignal.timeout(30_000), body: JSON.stringify(body),
});
if (!response.ok) throw new Error(`HTTP ${response.status}: ${await response.text()}`);
if (response.body) {
for await (const chunk of response.body) process.stdout.write(chunk);
}
} catch (error) {
console.error(error.message);
process.exitCode = 1;
}
Respostas e erros
201 Resposta bem-sucedida.
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
id | string | Sim | Identificador opaco; mantenha-o como cadeia. minLength: 1 |
project_id | string | Sim | Identificador opaco; mantenha-o como cadeia. minLength: 1 |
service | string | Sim | Serviço do projeto.monitoring |
book_address_id | string | Sim | ID do endereço correspondente no livro de endereços. minLength: 1 |
status | string | Sim | Estado da associação projeto/endereço.active, paused, deleted |
chain | string | Sim | Código da rede. |
address | string | Sim | Endereço normalizado. |
asset | string | Sim | Ativos na cadeia de resposta; vários ativos separados por vírgulas. |
meta | object | Não | Etiqueta e nota do endereço, se definidas. |
watched_as | string | Não | Identificador adicional do endereço, quando utilizado pela rede. |
sandbox | boolean | Não | true para monitorização de teste; omissão significa false. |
watch_outgoing | boolean | Sim | Se as operações de saída são monitorizadas. |
origin_kinds | string[] | Sim | Formas de adicionar o endereço ao projeto. |
created_at | string | Sim | Data e hora UTC em RFC 3339.date-time |
201 application/json
{
"id": "1008",
"project_id": "1002",
"service": "monitoring",
"book_address_id": "1007",
"status": "active",
"chain": "ethereum",
"address": "0x52908400098527886E0F7030069857D2E4169EE7",
"asset": "native",
"sandbox": true,
"watch_outgoing": false,
"origin_kinds": [
"manual"
],
"created_at": "2026-10-06T10:00:00Z"
}400 Pedido inválido (bad_request, unsupported_asset).
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
error | object | Sim |
400 application/json
{
"error": {
"code": "forbidden",
"message": "this API key is read-only"
}
}401 Nenhuma chave API ativa válida (unauthorized).
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
error | object | Sim |
401 application/json
{
"error": {
"code": "forbidden",
"message": "this API key is read-only"
}
}402 Limite de recursos atingido (limit_reached).
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
error | object | Sim |
402 application/json
{
"error": {
"code": "forbidden",
"message": "this API key is read-only"
}
}403 Chave não permite operação, projeto, serviço ou IP; email não confirmado.
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
error | object | Sim |
403 application/json
{
"error": {
"code": "forbidden",
"message": "this API key is read-only"
}
}409 Conflito de estado, parâmetros de repetição incompatíveis ou limite de recursos de pagamento (conflict, limit_reached, service_inactive).
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
error | object | Sim |
409 application/json
{
"error": {
"code": "forbidden",
"message": "this API key is read-only"
}
}429 Demasiados pedidos (rate_limited); repita após Retry-After.
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
error | object | Sim |
429 application/json
{
"error": {
"code": "forbidden",
"message": "this API key is read-only"
}
}500 Erro interno (internal).
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
error | object | Sim |
500 application/json
{
"error": {
"code": "forbidden",
"message": "this API key is read-only"
}
}503 Indisponibilidade temporária (unavailable); repita com espera progressiva.
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
error | object | Sim |
503 application/json
{
"error": {
"code": "forbidden",
"message": "this API key is read-only"
}
}Objetos aninhados
Watch
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
id | string | Sim | Identificador opaco; mantenha-o como cadeia. minLength: 1 |
project_id | string | Sim | Identificador opaco; mantenha-o como cadeia. minLength: 1 |
service | string | Sim | Serviço do projeto.monitoring |
book_address_id | string | Sim | ID do endereço correspondente no livro de endereços. minLength: 1 |
status | string | Sim | Estado da associação projeto/endereço.active, paused, deleted |
chain | string | Sim | Código da rede. |
address | string | Sim | Endereço normalizado. |
asset | string | Sim | Ativos na cadeia de resposta; vários ativos separados por vírgulas. |
meta | object | Não | Etiqueta e nota do endereço, se definidas. |
watched_as | string | Não | Identificador adicional do endereço, quando utilizado pela rede. |
sandbox | boolean | Não | true para monitorização de teste; omissão significa false. |
watch_outgoing | boolean | Sim | Se as operações de saída são monitorizadas. |
origin_kinds | string[] | Sim | Formas de adicionar o endereço ao projeto. |
created_at | string | Sim | Data e hora UTC em RFC 3339.date-time |
ID
Identificador opaco. Formato não garantido; não converta em número.
string Identificador opaco. Formato não garantido; não converta em número.
StringMap
object
WatchRequest
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
project | string | Não | ID do projeto. Obrigatório ao listar ou criar monitorizações salvo chave limitada a projeto. Noutras operações, omitir usa o contexto de conta/projeto da operação; defina explicitamente. |
chain | string | Sim | Código da rede de GET /v1/chains. minLength: 1 |
address | string | Sim | Endereço na rede selecionada; validado e normalizado. minLength: 1 |
asset | string | Não | Ativo predefinido para exact: native, símbolo suportado ou identificador do token. Predefinição: native |
label | string | Não | Etiqueta do livro de endereços. maxLength: 60 |
note | string | Não | Nota facultativa do livro de endereços. maxLength: 280 |
watch_outgoing | boolean | Não | Receber também operações de saída; a rede tem de as suportar. Predefinição: false |
asset_policy | string | Não | exact seleciona um ativo; allow usa asset_ids; all seleciona todos os ativos da rede. Redes sem tokens só suportam native/exact.exact, allow, all; Predefinição: exact |
asset_ids | string[] | Não | Exatamente um para exact, pelo menos um para allow, vazio para all. Com exact e lista vazia, é usado asset. maxItems: 100 |
excluded_asset_ids | string[] | Não | Ativos a excluir. maxItems: 100 |
min_confirmations | integer | Não | Confirmações mínimas. Predefinição: 0; minimum: 0 |
min_amount | string | Não | Limiar não negativo em unidades mínimas, não montante decimal. pattern: ^[0-9]+$ |
watch_contracts | boolean | Não | Receba eventos de contrato suportados. Predefinição: false |
watch_unexpected_assets | boolean | Não | Receba eventos de ativos inesperados. Predefinição: false |
RawAmount
string
Error
| Campo | Tipo | Obrigatório | Descrição |
|---|---|---|---|
error | object | Sim |